# Build type
set(build_type "Release" CACHE STRING "Build type: Release or Debug")

# Support features
set(omp true CACHE BOOL "OpenMP support")
set(simd true CACHE BOOL "SIMD support")

# BLAS / LAPACK
set(lapack_path /usr/local/opt/openblas/lib/ CACHE FILEPATH "Path where the LAPACK library is located")
set(lapackblas_library "-lopenblas" CACHE STRING "BLAS/LAPACK library name for linking")

# HDF5 
set(hdf5_prefix /usr/local CACHE FILEPATH "Prefix where the HDF5 library has been installed")

# Fortran compiler flags
set(Fortran_FLAGS "-cpp -ffast-math -funroll-loops -march=native" CACHE STRING "Fortran compiler flags ")

