# Build type
set(build_type "Release" CACHE STRING "Build type: Release or Debug")

# Support features
set(omp true CACHE BOOL "OpenMP support")
set(simd true CACHE BOOL "SIMD support")

# BLAS / LAPACK
set(lapack_path $ENV{MKLROOT}/lib/intel64 CACHE FILEPATH "Path where the LAPACK library is located")
set(lapackblas_library "-mkl" CACHE STRING "BLAS/LAPACK library name for linking")

# HDF5 
set(hdf5_prefix /usr/local CACHE FILEPATH "Prefix where the HDF5 library has been installed")

# Fortran compiler flags
set(Fortran_FLAGS "-no-prec-div -fp-model fast=2" CACHE STRING "Fortran compiler flags ")