module Mgrid1D
!==================================================================
   use Mdef,only: dp
   implicit none
!------------------------------------------------------------------
   private
   public :: grid1d_t
!------------------------------------------------------------------
   type grid1d_t
      integer :: Npts
      real(dp) :: Xmin,Xmax,dX
      real(dp),allocatable :: Xpts(:) 
   contains 
      procedure :: Init => mesh_Init
      procedure :: Clean => mesh_Clean
   end type grid1d_t
!------------------------------------------------------------------
contains
!------------------------------------------------------------------  
   subroutine mesh_Init(Mesh,Npts,Xmin,Xmax)
      class(grid1d_t) :: Mesh
      integer,intent(in)  :: Npts
      real(dp),intent(in) :: Xmin,Xmax
      integer :: i

      Mesh%XMIN = Xmin
      Mesh%XMAX = Xmax
      Mesh%Npts = Npts
      if(.not.allocated(Mesh%Xpts)) allocate(Mesh%Xpts(0:Mesh%Npts))
      Mesh%dX=(Mesh%Xmax-Mesh%Xmin)/Mesh%Npts
      do i=0,Mesh%Npts
         Mesh%Xpts(i)=Mesh%Xmin+Mesh%dX*i
      end do

   end subroutine Mesh_Init
!------------------------------------------------------------------
   subroutine mesh_Clean(Mesh)
      class(grid1d_t) :: Mesh

      if(allocated(Mesh%Xpts)) deallocate(Mesh%Xpts)

   end subroutine Mesh_Clean
!------------------------------------------------------------------


!==================================================================
end module Mgrid1D
