!--------------------------------------------------------------------------------------
  subroutine Init_CntrFun_2time_KB(CntrFun_2tm,FermBos,Beta,Nstates,Nt1,Nt2,Ntau)
    class(CntrFun_2time_t)::CntrFun_2tm
    integer,intent(in)::FermBos,Nstates,Nt1,Nt2,Ntau
    real(dp),intent(in)::Beta

    allocate(CntrFun_2tm%Lesser(Nstates,Nstates,0:Nt2,0:Nt1))
    allocate(CntrFun_2tm%Greater(Nstates,Nstates,0:Nt1,0:Nt2))
    allocate(CntrFun_2tm%Left(Nstates,Nstates,0:Nt1,0:Ntau))
    allocate(CntrFun_2tm%Mats(Nstates,Nstates,0:Ntau))

    CntrFun_2tm%Lesser=zero
    CntrFun_2tm%Greater=zero
    CntrFun_2tm%Left=zero
    CntrFun_2tm%Mats=zero

    CntrFun_2tm%Nstates=Nstates
    CntrFun_2tm%Nt1=Nt1
    CntrFun_2tm%Nt2=Nt2
    CntrFun_2tm%Ntau=Ntau
    CntrFun_2tm%FermBos=FermBos
    CntrFun_2tm%Beta=Beta

    CntrFun_2tm%Initialized=.true.

  end subroutine Init_CntrFun_2time_KB
!--------------------------------------------------------------------------------------
  subroutine Init_CntrFun_2time_Keld(CntrFun_2tm,FermBos,Beta,Nstates,Nt,Nt2)
    class(CntrFun_2time_t) :: CntrFun_2tm
    integer,intent(in)     :: FermBos,Nstates,Nt
    real(dp),intent(in)    :: Beta
    integer,intent(in),optional :: Nt2
    integer :: Nt2_

    Nt2_ = Nt
    if(present(Nt2)) Nt2_ = Nt2

    allocate(CntrFun_2tm%Lesser(Nstates,Nstates,0:Nt,0:Nt))
    allocate(CntrFun_2tm%Greater(Nstates,Nstates,0:Nt,0:Nt))

    CntrFun_2tm%Lesser=zero
    CntrFun_2tm%Greater=zero

    CntrFun_2tm%Nstates=Nstates
    CntrFun_2tm%Nt1=Nt
    CntrFun_2tm%Nt2=Nt
    CntrFun_2tm%Ntau=0
    CntrFun_2tm%FermBos=FermBos
    CntrFun_2tm%Beta=Beta

    CntrFun_2tm%Initialized=.true.

  end subroutine Init_CntrFun_2time_Keld
!--------------------------------------------------------------------------------------
  subroutine Free_CntrFun_2time(CntrFun)
    class(CntrFun_2time_t)::CntrFun

    if(allocated(CntrFun%Lesser)) deallocate(CntrFun%Lesser)
    if(allocated(CntrFun%Greater)) deallocate(CntrFun%Greater)
    if(allocated(CntrFun%Left)) deallocate(CntrFun%Left)
    if(allocated(CntrFun%Mats)) deallocate(CntrFun%Mats)

    CntrFun%Initialized=.false.

  end subroutine Free_CntrFun_2time
!--------------------------------------------------------------------------------------
  pure subroutine CntrFun_2time_SetZero(CntrFun,tstp)
    class(CntrFun_2time_t),intent(inout) :: CntrFun
    integer,intent(in),optional :: tstp

    if(present(tstp)) then
       CntrFun%Lesser(:,:,0:,tstp)=zero
       CntrFun%Greater(:,:,tstp,0:)=zero
       if(allocated(CntrFun%Left)) then
          CntrFun%Left(:,:,tstp,0:)=zero
       end if
    else
       CntrFun%Lesser(:,:,0:,0:)=zero
       CntrFun%Greater(:,:,0:,0:)=zero
       if(CntrFun%Ntau > 0) then
          CntrFun%Left(:,:,0:,0:)=zero
          CntrFun%Mats(:,:,0:)=zero
       end if
    end if

  end subroutine CntrFun_2time_SetZero
!--------------------------------------------------------------------------------------
  pure subroutine CntrFun_2time_Matrix_Retarded(CntrFun,it,jt,CntrFun_Ret)
    integer,intent(in)::it,jt
    class(CntrFun_2time_t),intent(in)::CntrFun
    complex(dp),dimension(:,:),intent(out)::CntrFun_Ret

    CntrFun_Ret=CntrFun%Greater(:,:,it,jt) - CntrFun%Lesser(:,:,it,jt)

  end subroutine CntrFun_2time_Matrix_Retarded
!--------------------------------------------------------------------------------------
  pure subroutine CntrFun_2time_Matrix_Advanced(CntrFun,it,jt,CntrFun_Ad)
    integer,intent(in)::it,jt
    class(CntrFun_2time_t),intent(in)::CntrFun
    complex(dp),dimension(:,:),intent(out)::CntrFun_Ad

    CntrFun_Ad=CntrFun%Lesser(:,:,it,jt) - CntrFun%Greater(:,:,it,jt)

  end subroutine CntrFun_2time_Matrix_Advanced
!--------------------------------------------------------------------------------------
  pure subroutine CntrFun_2time_Matrix_Right(CntrFun,it,itau,CntrFun_Right)
    class(CntrFun_2time_t),intent(in)::CntrFun
    integer,intent(in)::it,itau
    complex(dp),dimension(:,:),intent(out)::CntrFun_Right
    integer::ktau

    ktau=CntrFun%Ntau-itau
    CntrFun_Right = -sign(1,CntrFun%FermBos)*conjg(transpose(CntrFun%Left(:,:,it,ktau)))

  end subroutine CntrFun_2time_Matrix_Right
!--------------------------------------------------------------------------------------
  pure subroutine CntrFun_2time_symmetrize(CntrFun,it)
    class(CntrFun_2time_t),intent(inout)::CntrFun
    integer,intent(in)::it
    integer::jt

    associate(n => CntrFun%Nstates)

      do jt=0,it-1
         CntrFun%Lesser(1:n,1:n,it,jt) = -conjg(transpose(CntrFun%Lesser(1:n,1:n,jt,it)))
         CntrFun%Greater(1:n,1:n,jt,it) = -conjg(transpose(CntrFun%Greater(1:n,1:n,it,jt)))
      end do

    end associate

  end subroutine CntrFun_2time_symmetrize
!--------------------------------------------------------------------------------------
  pure function CntrFun_2time_Rho_eq(CntrFun) result(Rho)
    class(CntrFun_2time_t),intent(in)::CntrFun
    complex(dp),dimension(CntrFun%Nstates,CntrFun%Nstates)::Rho

    Rho = -CntrFun%Mats(:,:,CntrFun%Ntau)

  end function CntrFun_2time_Rho_eq
!--------------------------------------------------------------------------------------
  pure function CntrFun_2time_Rho_neq(CntrFun,it) result(Rho)
    class(CntrFun_2time_t),intent(in)::CntrFun
    integer,intent(in)::it
    complex(dp),dimension(CntrFun%Nstates,CntrFun%Nstates)::Rho

    Rho = -iu*CntrFun%Lesser(:,:,it,it)

  end function CntrFun_2time_Rho_neq
!--------------------------------------------------------------------------------------
  subroutine Init_2time_array_L(func,N,FermBos,Beta,Nstates,Nt,Ntau)
    type(CntrFun_2time_t),allocatable,intent(inout) :: func(:)
    integer,intent(in)  :: N
    integer,intent(in)  :: FermBos
    real(dp),intent(in) :: Beta
    integer,intent(in)  :: nstates
    integer,intent(in)  :: Nt
    integer,intent(in)  :: Ntau
    integer :: i

    allocate(func(N))
    do i=1,N
       call func(i)%Init(FermBos,Beta,Nstates,Nt,Nt,Ntau)
    end do

  end subroutine Init_2time_array_L
!--------------------------------------------------------------------------------------
  subroutine Init_2time_array_Keld(func,N,FermBos,Beta,Nstates,Nt)
    type(CntrFun_2time_t),allocatable,intent(inout) :: func(:)
    integer,intent(in)  :: N
    integer,intent(in)  :: FermBos
    real(dp),intent(in) :: Beta
    integer,intent(in)  :: nstates
    integer,intent(in)  :: Nt
    integer :: i

    allocate(func(N))
    do i=1,N
       call func(i)%Init_Keldysh(FermBos,Beta,Nstates,Nt)
    end do

  end subroutine Init_2time_array_Keld
!--------------------------------------------------------------------------------------
  subroutine Clean_2time_array(func)
    type(CntrFun_2time_t),allocatable,intent(inout) :: func(:)
    integer :: i

    do i=1,size(func)
       call func(i)%Clean()
    end do
    deallocate(func)

  end subroutine Clean_2time_array
!--------------------------------------------------------------------------------------

